<template>
  <div class="ac-table">
    <div
      v-show="is_loading"
      class="loader"
    >
      <img
        :src="loading_image"
        class="loader__image"
        alt="loader"
      >
    </div>

    <header class="ac-table__header">
      <!-- @slot Use this slot for table header -->
      <slot name="header"></slot>
    </header>

    <b-table
      hover
      bordered
      :items="data"
      :fields="table_columns"
      @row-clicked="$emit('row_clicked', $event)"
      @row-dblclicked="$emit('row_dblclicked', $event)"
    >
      <!-- Checkbox template. Only shown when bulk property is true -->
      <template
        slot="#"
        slot-scope="data"
      >
        <div>
          <b-form-checkbox
            v-model="selected"
            :value="data.item.id"
            @change="$emit('checkbox_clicked', data.item)"
          />
        </div>
      </template>

      <!--
        Dropdown template. Only shown when dropdown property is true
        and prop dropdown_options.options is present
       -->
      <template
        slot="options"
        slot-scope="data"
      >
        <div class="text-center">
          <ac-material-dropdown
            :options="dropdown_options_handler"
            :button_options="dropdown_options.button_options"
            :right="true"
            @item_click="on_dropdown_item_click($event, data.item)"
          />
        </div>
      </template>
    </b-table>

    <div
      v-show="load_more_type === 'loadMoreButton'"
      ref="loader_div"
      class="load-more text-center mt-2"
    >
      <!--
        @slot Slot for load more button, shown only if load_more_type is 'loadMoreButton'
        and there is more data to fetch
      -->
      <slot name="load_more_button"></slot>
    </div>
  </div>
</template>

<script>
import acCollection from './ac-collection.vue'
import acMaterialDropdown from './ac-material-dropdown.vue'

/**
 * ac Table component which can be used to display data from API in table view
 * @requires VueBootstrap
 * @requires ac-collection.vue
 * @requires ac-material-dropdown.vue
 *
 * Fires event on row click and row double click
 * @event row_clicked
 * @event row_dblclicked
 * @type {object} row data
 *
 * @event checkbox_clicked
 * @type {object} row data
 */

export default {
  name: 'ac-collection-table',

  extends: acCollection,

  components: {
    acMaterialDropdown,
  },

  props: {
    /**
     * @param {array} columns - list of table columns.
     */
    columns: {
      type: Array,
      required: true,
    },

    /**
     * @param {boolean} bulk - Whenever true show checkbox in the first column
     */
    bulk: {
      type: Boolean,
      default: false,
    },

    /**
     * @param {boolean} dropdown - Whenever true show dropdown in the last column
     */
    dropdown: {
      type: Boolean,
      required: true,
    },

    /**
     * @param {object} dropdown_options - Options for dropdown menu for each row
     * Required if dropdown prop is true
     */
    dropdown_options: {
      type: Object,
      required: false,
    },

    /**
     * @param {object} col_attributes - Remove requirement for col_attributes attribute
     * As table is used, no columns present
     */
    col_attributes: {
      type: Object,
      required: false,
      default: () => ({}),
    },
  },

  data() {
    return {
      selected: [],
    }
  },

  computed: {
    /**
     * @function table_columns
     * @private
     * Adds column depending on bulk and dropdown props
     */
    table_columns() {
      const cols = [...this.columns]

      if (this.bulk) {
        cols.unshift('#')
      }

      if (this.dropdown) {
        cols.push('options')
      }

      return cols
    },

    /**
     * @function dropdown_options_handler
     * @private
     * Depends on dropdown_options prop
     * If dropdown prop is true - checks for dropdown_options presense
     */
    dropdown_options_handler() {
      if (!this.dropdown) return []

      if (this.dropdown && !this.dropdown_options) {
        console.error('dropdown_options is required when dropdown prop is true')
        return []
      }

      if (!this.dropdown_options.options) {
        console.error('dropdown_options.options array is required')
        return []
      }

      return [...this.dropdown_options.options]
    },
  },

  methods: {
    /**
     * @function get_selected
     * @public
     * @returns {array} id's array of checked rows
     */
    get_selected() {
      return [...this.selected]
    },

    /**
     * Sets checked rows
     * @function set_selected
     * @public
     * @param {array} data - array of row ids
     */
    set_selected(data) {
      this.selected = [...data]
    },

    /**
     * Dropdown click handler
     * @function on_dropdown_item_click
     * @public
     * @param {string} type - type of click e.g. 'edit'
     * @param {object} item - row info related to clicked dropdown
     */
    on_dropdown_item_click(type, item) {
      this.$emit('dropdown_click', {
        type,
        item,
      })
    },
  },
}
</script>

<style scoped>
.loader {
  position: fixed;
  display: flex;
  align-items: center;
  justify-content: center;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  z-index: 999;
  background-color: rgba(255, 255, 255, .65);
}
</style>
